//---------------------------------------------------------------------------

#ifndef canvasPainter
#define canvasPainter
#include "grect.h"
#include "gbitmap.h"
#include "font.h"
#include "cstring.h"
#include <vcl.h>


class GcanvasPainter{
  public:
      GcanvasPainter(GgraphicsBitmap *acanvas);
      int drawRect(Grect &rect, Gcolor &color);
      int drawRectGradient(Grect &rect,  Gcolor &color, Gcolor &color1);
      int borderColor(int width,int padding, Gcolor color);
      int drawText(Grect &rect,Gfont *font, string text, Gcolor color, TextAlignment textAlignment);
      int drawBitmap(GgraphicsBitmap *bitmap,Grect rect, int x, int y );
      int drawBitmapTransparent(GgraphicsBitmap *bitmap, Grect rect,Gcolor &color);
      void upLines(int index, int countLines, int top);
      void downLines(int index, int countLines, int top);
      int backgroundColor(Gcolor color);
      GgraphicsBitmap *getBitmap();
 private:
      GgraphicsBitmap *canvas;
      void iputc(int x, int y, Gcolor color, Gfont &font ,const char c);

} ;

//---------------------------------------------------------------------------
#endif
