//---------------------------------------------------------------------------

#ifndef controlH
#define controlH

#include "list.h"
#include "object.h"
#include "cstring.h"
#include "gbitmap.h"
#include "canvasPainter.h"

enum controlBorederStyle {
    bsNone, bsSingle
};

enum controlAlign {
    alignNone, alignTop, alignBottom, alignLeft, alignRight, alignClient, alignCustom
};

enum controlEventType {
    etClickDown, etClickUp , etKeyDown , etMauseMove , etDoubleClick
};



class Gcontrol : GgraphicsBitmap, public Gobject{
           typedef void (eventOnClick) (Gcontrol*, int x, int y);
           typedef void (eventOnKeyPress) (Gcontrol*, int key);
           typedef void (eventOnFocused)(Gcontrol* sender);
   public:
         Gcontrol(int left,int top,int width,int height,Gcontrol *parent);
         Gcontrol();
         void alingTo(controlAlign alignToParent);
         GcanvasPainter *canvas;	                                 //Opciones para pintar sobre el componente
         GcanvasPainter *containerlayout;                                //Es donde se pinta para luego mostrarse en pantalla
         int getleft() {return left;};
         void setleft(int left);
         void settop(int left);
         int gettop() {return top;};
         int getwidth(){return width();};
         int getheight(){return height();};
         void resizeControl(int width,int height);
         void setvisible(bool visible);
         bool getvisible(){return visible;};
         int insertChildControl(Gcontrol *childControl);
         void refresh();
         void refresh(Grect rect);
         int removeControl(Gcontrol* control);
         Gcontrol* getControl(Gcontrol *control, int x, int y); 
         void setzindex(int zindex);
         Gcontrol *parent;	                //El padre representativo para determinar la posicion y el tamao del dibujo del componente
         eventOnClick *onClickDown;
         eventOnClick *onClickUp;
         eventOnKeyPress *onKeyPress;
         eventOnFocused *onFocused;
         eventOnClick *onMouseMove;
         eventOnClick *onDoubleClick;
         bool focus;
          Grect  drawRect;   
   private:
       //  Grect  drawRect;                        //Recta de dibujo actual sobre el padre se usa para dibujar la parte visible del componenete en el contenedor
         Grect  realRect;                        //recta original dentro del padre  no acepta left y top -
         int left,top;                           //Solo para almacenar posicion relativa al padre puede ser - o +
         Clist controls;
         int zindex;                            //Orden para mostrar los componenetes que se solapen
         bool visible;
         void rebuildControl();
         void rebuildControlsChilds();
         void repaintZone(Grect rect, int index);
         void clearToParent(Grect rect, int index);
         void moveToRelativeParent();
         void drawRectToLayout(Grect rect);
};


//---------------------------------------------------------------------------
#endif
