//---------------------------------------------------------------------------
#pragma hdrstop

#include "gbitmap.h"
GgraphicsBitmap::GgraphicsBitmap(int width, int height) : Grect(0,0, width, height) {
    glinearBuffer = new int[(width + 1)*(height + 1)];
    isExternGrpahics = false;
}

GgraphicsBitmap::GgraphicsBitmap(int width, int height, int *externLinearBuffer)  : Grect(0,0, width, height) {
    glinearBuffer =  externLinearBuffer;
    isExternGrpahics = true;
}

void GgraphicsBitmap::setGraphicsBitmap(int *externGraphicsBitmap){
     glinearBuffer =  externGraphicsBitmap;
     isExternGrpahics = true;
}

void GgraphicsBitmap::resizeBitmap(int width,int height){
    setwidth(width);
    setheight(height);
    if (!isExternGrpahics){
       delete(glinearBuffer);
       glinearBuffer = new int[(width + 1)*(height + 1)];
    }


}

int *GgraphicsBitmap::getLine(int y){
    return &glinearBuffer[y*width()];
}

int* GgraphicsBitmap::getGraphicsBitmap() {
    return glinearBuffer;
}

GgraphicsBitmap::~GgraphicsBitmap() {
    if (!isExternGrpahics)
       delete(glinearBuffer);
}


//---------------------------------------------------------------------------

#pragma package(smart_init)
