/*Copyright (C) 2019  Ramn Mayedo Morales (ramonmayedo@gmail.com)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

#include "GWbartitle.h"
#include "Gwindows.h"
#include "Gclient.h"
#include "canvasPainter.h"

extern int icoClose;
extern int icoMinimized;

void buttonMinimizedOnClickUp(Gcontrol *sender, int x, int y);
void buttonColoseOnClickUp(Gcontrol *sender, int x, int y);

GWbartitle::GWbartitle() : Gcontrol(0,0,200,100,0){
    setClassName("GWbartitle");
}

GWbartitle::GWbartitle(int x, int y, int width, int height, Gcontrol *parent) : Gcontrol(x, y, width, height,parent) {
    setClassName("GWbartitle");
    color = 0x00544f4d;
    initialized();
}

void GWbartitle::repaint() {
    canvas->drawRectGradient(Grect(0,0,getwidth(),getheight()),Gcolor(0x00c9c9c9),Gcolor(clWhite));
    canvas->drawText(Grect(0,0,getwidth(),font->height),font,caption,clBlack,3);
}

GWbartitle::~GWbartitle() {
}

void GWbartitle::initialized() {
    font = new Gfont();
    repaint();
    bClose = new Gbutton(2, 1, 25, 25,this);
    bClose->bitmap =  new GgraphicsBitmap(16,16,&icoClose);
    //bClose->border = btbSolid;
    bClose->style = styGrey;
    bClose->onClickUp = buttonColoseOnClickUp;
    bClose->repaint();
    bMinimized = new Gbutton(29, 1, 25, 25,this);
    bMinimized->bitmap =  new GgraphicsBitmap(16,16,&icoMinimized);
    bMinimized->parent = this;
    //bMinimized->border = btbSolid;
    bMinimized->onClickUp = buttonMinimizedOnClickUp;
    bMinimized->style = styGrey;
    bMinimized->repaint();
}

void buttonMinimizedOnClickUp(Gcontrol *sender, int x, int y) {
   Gwindows *windows = (Gwindows*) (sender->parent->parent);
 //  ((Gclient*)windows->application)->applicationCommand(cmsMinimizedWindows);
}

void buttonColoseOnClickUp(Gcontrol *sender, int x, int y) {
    Gwindows *windows = (Gwindows*) (sender->parent->parent);
   // ((Gclient*) windows->application)->applicationCommand(cmsCloseWindows);
}