#include "Gbutton.h"
#include "string.h"
#include "canvasPainter.h"
#include "Unit1.h"

Gbutton::Gbutton() {
    setClassName("Gbutton");
}

Gbutton::Gbutton(int x, int y, int width, int height,Gcontrol *parent) : Gcontrol(x, y, width, height,parent) {
    setClassName("Gbutton");
    initialized();
}

 void Gbutton::focused(){
     //if (focus == false)
  //       refresh();
 }


void Gbutton::repaint() {
    int backGroundColor, borderColor;
    int backGroundColorFocus;
    int pres;

    switch(style){
       case styGrey :{
           backGroundColor = 0xd4d4d4;
           backGroundColorFocus = 0x545454;
           borderColor = 0x004f4f4f;
           break;
       };
         case styBlue :{
           backGroundColor = 0x00ff6666;
           backGroundColorFocus = 0x00cc3333;
           borderColor =  0x004f4f4f ;
           break;
       };
    };

    canvas->backgroundColor(Gcolor(backGroundColor));

    if (bstate == bsNormal) {
        //if (border)
        canvas->borderColor(1, 0 ,Gcolor(borderColor));
        Grect rbottom(0, getheight()-2, getwidth(), 2);
        canvas->drawRect(rbottom, Gcolor(borderColor));
        Grect rleft(getwidth()-2, 0, 2, getheight());
        canvas->drawRect(rleft, Gcolor(borderColor));
        pres = 0;
      } else if (bstate == bsClicked) {
        Grect top(0, 0, getwidth(), 2);
        canvas->drawRect(top, Gcolor(borderColor));
        Grect right(0, 0, 2, getheight());
        canvas->drawRect(right, Gcolor(borderColor));
        canvas->borderColor(1, 0 ,Gcolor(borderColor));
        pres = 1;
    }

    if (bitmap){
        bitmap->alignCenter(Grect(pres,0, getwidth(), getheight()));
        canvas->drawBitmapTransparent(bitmap,*(Grect*)bitmap,Gcolor(0x00FFFFFF));
    }
    if (caption.Lenght())
        canvas->drawText(Grect(pres,0,getwidth(),font->height),font,caption,clBlack,2);
}


void Gbutton::initialized() {
    bstate = bsNormal;
    font = new Gfont();
    bitmap = 0;
}

void Gbutton::clickPressDown(Gcontrol* sender, int x, int y) {
    bstate = bsClicked;
    repaint();
    refresh();
}

void Gbutton::clickPressUp(Gcontrol* sender, int x, int y) {
    bstate = bsNormal;
    repaint();
    refresh();
}

 void Gbutton::mouseMove(Gcontrol *sender, int x, int y){
     /* if (!(graphics->drawRect.constains(x,y))) {
      ShowMessage("a");
           bstate = bsNormal;
           refresh();
     }   */
}

Gbutton::~Gbutton() {

}