/*Copyright (C) 2019  Ramn Mayedo Morales (ramonmayedo@gmail.com)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>
*/

#include "GlistBox.h"

 void onScrollBy(Gcontrol *sender, int x,int y);

GlistBox::GlistBox(int x, int y, int width, int height, Gcontrol *control) : GcontrolScrolled(x, y, width, height, control) {
    setClassName("GlistBox");   //Valores por defecto
    color = 0xd4d4d4;
    selected = 0xFF00FF08;
    itemHeight = 20;
    itemIndex = -1;
    font = new Gfont();
    vScrollBar->inc =  font->height;
    hScrollBar->inc =  font->width;
    //vScrollBar->repaint();
    //hScrollBar->repaint();
    updateSizeContent(width, height);
    maxContentHeight =  height;
    maxContentWidth = width;
    vScrollBar->onScrollBy = onScrollBy;
    itemHeight =  (font->height + 1);
    maxItemsPaint = realDrawContent.height() / itemHeight;
    itemsRect =  Grect(5, 5,realDrawContent.width(),font->height);
}

void GlistBox::repaint() {

     for (int i=0;i<strings.count();i++){
         if (i< maxItemsPaint)
         paintLine(i,0,0,Gcolor(clBlack));
     }
}



void GlistBox::onScroll(int x, int y){

}


void GlistBox::scrollBy(int x, int y) {
 if (y){
     canvas->upLines(5, itemHeight, (maxItemsPaint - 1) * itemHeight + 5);
     refresh(realDrawContent);
 }

}

void GlistBox::selectItem(int x, int y) {

}

void GlistBox::focused() {

}

void GlistBox::keyPress(int &key) {

}

GlistBox::~GlistBox() {

}

void onScrollBy(Gcontrol *sender, int x, int y) {    //Conecta al scrollBar con el componente externo
     ((GlistBox*)sender->parent)->scrollBy(0,1);
}

void GlistBox::initialized() {  

}

void GlistBox::paintScrollDown() {

}

void GlistBox::paintScrollUp() {

}

void GlistBox::paintLine(int y, int x, int dy, Gcolor color) {
     itemsRect.sety(y*itemHeight+5);
     canvas->drawText(itemsRect,font,strings[y]->c_str(),color,alNone);
}

void GlistBox::paintAllItmes(int y, int x) {

}

void GlistBox::needScrollDown() {

}

void GlistBox::needScrollUp() {

}

void GlistBox::add(string str) {
    bool needUpdateSizecontent =false;
    string *nuevo = new string(str);
    int textWidth = str.Lenght()*(font->width + 2);
    if (textWidth > maxContentWidth) {
      maxContentWidth = textWidth;
      needUpdateSizecontent = true;
    }
    strings.add(nuevo);
    int textHeight = strings.count() * (font->height + 2);
    if (textHeight > maxContentHeight){
        maxContentHeight = textHeight;
        needUpdateSizecontent = true;
    }
     if (needUpdateSizecontent)
         updateSizeContent(maxContentWidth,maxContentHeight);
}

void GlistBox::load() {

}