#include "GscrollBar.h"

#include "canvasPainter.h"

#include "Unit1.h"
                                    //*******OK**************
 extern int icoArrowUp;
 extern int icoArrowDown;
 extern int icoArrowLeft;
 extern int icoArrowRight;
 
GscrollBar::GscrollBar() {
    setClassName("GscrollBar");
}

GscrollBar::GscrollBar(int x, int y, int width, int height,scrollBarKind kind ,Gcontrol *control) : Gcontrol(x, y, width, height, control) {
    setClassName("GscrollBar");
    color = 0x84351a;
    max = 0;
    inc = 1;
    min = 0;
    position = 0;
    onScrollBy = 0;
    this->kind = kind;
    clickedCursor = false;
    initialized();
}

GscrollBar::~GscrollBar() {

}

void GscrollBar::initialized() {
   if (kind == kindVertical){
       int realWidth = getwidth();
       canvas->borderColor(1,0,Gcolor(0x00a4a4a4));

       bup1 = new Grect(1,1,realWidth-2,realWidth-2);
       bup = new GgraphicsBitmap(16,16,&icoArrowUp);
       bup->alignCenter(*bup1) ;
       canvas->drawRect(*bup1,Gcolor(0xd4d4d4));
       canvas->drawBitmapTransparent(bup,*(Grect*)bup,Gcolor(clWhite));

       bdown1 = new Grect(1,getheight()-realWidth+1,realWidth-2,realWidth-2);
       bdown =  new GgraphicsBitmap(16,16,&icoArrowDown);
       bdown->alignCenter(*bdown1) ;
       canvas->drawRect(*bdown1,Gcolor(0xd4d4d4));
       canvas->drawBitmapTransparent(bdown,*(Grect*)bdown,Gcolor(clWhite));

       bscroll1 = new Grect(1,realWidth - 1 ,realWidth-2, getheight() - realWidth*2+2);
       canvas->drawRect(*bscroll1,Gcolor(0xd4d4d4));

       int sizeCursor = bscroll1->height() - max ;
       if (sizeCursor < 10 )  sizeCursor = 10;

       cursor1 = new Grect(2,realWidth-1,realWidth-4, sizeCursor);
       canvas->drawRect(*cursor1,Gcolor(0x009e9e9e));
       paso = float(max)/(bscroll1->height() - cursor1->height());  

   }else {
       int realHeight = getheight();
    
       canvas->borderColor(1,0,Gcolor(0x00a4a4a4));

       bup1 = new Grect(1,1,realHeight-2,realHeight-2);
       canvas->drawRect(*bup1,Gcolor(0xd4d4d4));
       bup = new  GgraphicsBitmap(16,16,&icoArrowLeft);
       bup->alignCenter(*bup1) ;
       canvas->drawBitmapTransparent(bup,*(Grect*)bup,Gcolor(clWhite));

       bdown1 = new  Grect(getwidth()-realHeight+1 ,1,realHeight -2,realHeight-2);
       canvas->drawRect(*bdown1,Gcolor(0xd4d4d4));
       bdown =  new GgraphicsBitmap(16,16,&icoArrowRight);
       bdown->alignCenter(*bdown1) ;
       canvas->drawBitmapTransparent(bdown,*(Grect*)bdown,Gcolor(clWhite));

       bscroll1 = new Grect(realHeight -1 , 1 , getwidth() -  realHeight*2 + 2 , realHeight-2);
       canvas->drawRect(*bscroll1,Gcolor(0xd4d4d4));

        int sizeCursor = bscroll1->width() - max;
        if (sizeCursor < 10 )  sizeCursor=10;
        cursor1 = new Grect(realHeight -1, 2 , getwidth() - sizeCursor , realHeight-4);
        cursor1->setwidth((int)sizeCursor);
        canvas->drawRect(*cursor1,Gcolor(0x009e9e9e));
        paso = float(max)/(bscroll1->width() - cursor1->width());
   }
}

void GscrollBar::clickPressDown(Gcontrol* sender, int x, int y) {
    int ax = x - drawRect.x();
    int ay = y - drawRect.y();
   if (bup1->constains(ax,ay)){
       canvas->drawRect(*bup1,Gcolor(0x00e9e9e9));
       canvas->drawBitmapTransparent(bup,*(Grect*)bup,Gcolor(clWhite));
       refresh(*bup1);
       Grect delta = *cursor1;
       delta.move(-paso*inc,-paso*inc);
       scrollForce(delta,*cursor1);
   }else if (bdown1->constains(ax,ay)){
       canvas->drawRect(*bdown1,Gcolor(0x00e9e9e9));
       canvas->drawBitmapTransparent(bdown,*(Grect*)bdown,Gcolor(clWhite));
       refresh(*bdown1);
       Grect delta = *cursor1;
       delta.move(paso*inc,paso*inc);
       scrollForce(delta,*cursor1);
   }else  if (cursor1->constains(ax,ay)){
          clickedCursor = true;
          posClick = Gpoint(ax,ay);
   }else if (bscroll1->constains(ax,ay)){
       if (kind == kindVertical){
            if (ay > cursor1->bottom())
              posClick =  Gpoint(0,cursor1->bottom());
                else
              posClick =  Gpoint(0,cursor1->y());
              }
      else {
            if (ax > cursor1->right())
              posClick =  Gpoint(cursor1->right(),0);
                else
              posClick =  Gpoint(cursor1->x(),0);
      }
          scrollForce(Gpoint(ax,ay),posClick);
   }
}

void GscrollBar::clickPressUp(Gcontrol* sender, int x, int y) {
    x = x - drawRect.x();
    y = y - drawRect.y();
   if (bup1->constains(x,y)){
       canvas->drawRect(*bup1,Gcolor(0xd4d4d4));
       canvas->drawBitmapTransparent(bup,*(Grect*)bup,Gcolor(clWhite));
       refresh(*bup1);
   }else if (bdown1->constains(x,y)){
       canvas->drawRect(*bdown1,Gcolor(0xd4d4d4));
       canvas->drawBitmapTransparent(bdown,*(Grect*)bdown,Gcolor(clWhite));
       refresh(*bdown1);
   }
   if (clickedCursor)
      clickedCursor = false;
}

 void GscrollBar::onMouseMove(Gcontrol *sender, int x, int y){
   if (!(clickedCursor)) return;
     x = x - drawRect.x();
     y = y - drawRect.y();
     scrollForce(Gpoint(x,y), posClick);
     if (kind == kindVertical)
         posClick.sety(y);
      else
        posClick.setx(x);
}

void GscrollBar::scrollForce(Gpoint newPosition, Gpoint actualPosition){
     int deltaClick;
     if (kind == kindVertical)
        deltaClick = newPosition.y() -  actualPosition.y();
      else
        deltaClick = newPosition.x() -  actualPosition.x();
      if (deltaClick==0) return;

           canvas->drawRect(*cursor1,Gcolor(0xd4d4d4));
           refresh(*cursor1);

          if (kind == kindVertical){
              if (!(cursor1->bottom() + deltaClick < bscroll1->bottom())){
                 cursor1->sety(bscroll1->bottom()-cursor1->height()+1);
                 position = max;
              }else if (!(cursor1->y() + deltaClick > bscroll1->y())){
                 cursor1->sety(bscroll1->y());
                 position = 0;
              }else {
                 cursor1->move(0,deltaClick);
                 position = float((cursor1->y() -  bscroll1->y())*paso);
                   }
          }else{
                 if (!(cursor1->right() + deltaClick < bscroll1->right())){
                      cursor1->setx(bscroll1->right()-cursor1->width()+1);
                       position = max;
                 }else if (!(cursor1->x() + deltaClick > bscroll1->x())){
                       cursor1->setx(bscroll1->x());
                       position = 0;
                 }else{
                    cursor1->move(deltaClick,0);
                    position = float((cursor1->x() -  bscroll1->x())*paso);
                 }
           }
           canvas->drawRect(*cursor1,Gcolor(0x009e9e9e));
           refresh(*cursor1);
         //  if (onScrollBy)
         //      onScrollBy(this,0,0);
           Form1->Label1->Caption = position;
          
}


 void GscrollBar::repaint(){
     position = 0;
     if (kind == kindVertical){
       canvas->drawRect(*bscroll1,Gcolor(0xd4d4d4));
       int sizeCursor = bscroll1->height() - max ;
       if (sizeCursor < 10 )  sizeCursor = 10;
       cursor1->setheight(sizeCursor);
       cursor1->sety(23);
       canvas->drawRect(*cursor1,Gcolor(0x009e9e9e));
       paso = float(max)/(bscroll1->height() - cursor1->height());
   }else{
        canvas->drawRect(*bscroll1,Gcolor(0xd4d4d4));
        int sizeCursor = bscroll1->width() - max;
        if (sizeCursor < 10 )  sizeCursor=10;
        cursor1->setwidth(sizeCursor);
        cursor1->setx(23);
        canvas->drawRect(*cursor1,Gcolor(0x009e9e9e));
        paso = float(max)/(bscroll1->width() - cursor1->width());
   }
}
